/** \file formParsUtils.c
 *
 *  Implementation of formatting and parsing utility functions
 *
 *  Copyright (c) 2014, 2015  Albrecht Weinert, Bochum
 *
 *  This library is under construction.  <br />
 *  See all else in file formParsUtils.h
 *
 *  $Revision: 1 $
 *  $Date: 2017-01-25 11:27:06 +0000 (Wed, 25 Jan 2017) $
 */

#include "formParsUtils.h"
// #include <avr/pgmspace.h>


/* * This serves to format hex digits */
/// INFLASH(char const hexDig[]) = "0123456789ABCDEF????";

/*  Format the lower nibble to a hexadecimal digit
 *
 *  \param nib the value to format, only lower nibble (0..15)
 *  \return the hex digit '0'..'F'
 *  \internal  example of improve C by inline ASM
 */
uint8_t toHexDigit(uint8_t nib){
#if 1
   asm volatile( // avoids one extra register and two moves
      "andi %A0, 0x0F ; lower nibble \n"
      "subi %A0, lo8(-(48)) ; +'0' \n"
      "__ntd_%=:"
      : "=&r" (nib)
      :
   );
#else
   nib = (nib & 0x0F) + '0';
#endif
   if (nib > '9') nib += 'A' - ':';
   return nib;
   // return pgm_read_byte(& hexDig[nib & 0x0F]); takes longer than above
} // toHexDigit(uint8_t)
